import React from 'react';
import classnames from 'classnames';
import { Icon } from '@highlight-ui/icon';
import { Inline, Stack } from '@highlight-ui/layout';
import { Typography } from '@highlight-ui/typography';
import { parseMetadata } from '@highlight-ui/utils-commons';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var styles = {
  "container": "ProgressTracker-module__JF03-zWD__v1-3-10",
  "step": "ProgressTracker-module__mwzUwSJ1__v1-3-10",
  "isComplete": "ProgressTracker-module__YewiYBEo__v1-3-10",
  "isActive": "ProgressTracker-module__-RRp1AR4__v1-3-10",
  "stepNumber": "ProgressTracker-module__Um1iTgjv__v1-3-10",
  "contentContainer": "ProgressTracker-module__8JR9mk2q__v1-3-10",
  "description": "ProgressTracker-module__CN-Jvb3c__v1-3-10"
};
var ProgressTracker = function (_a) {
  var steps = _a.steps,
    stepNames = _a.stepNames,
    currentStepIndex = _a.currentStepIndex,
    metadata = _a.metadata,
    className = _a.className,
    _b = _a.hasLoadingSpinner,
    hasLoadingSpinner = _b === void 0 ? false : _b,
    _c = _a.hideProgressNumbers,
    hideProgressNumbers = _c === void 0 ? false : _c;
  /** Backwards compatibility support, convert the stepNames prop to an array of objects */
  var stepsArray = steps || (stepNames === null || stepNames === void 0 ? void 0 : stepNames.map(function (name) {
    return {
      name: name
    };
  }));
  if (!stepsArray) {
    return null;
  }
  return /*#__PURE__*/React.createElement("div", __assign({
    className: classnames(styles.container, className)
  }, parseMetadata(metadata)), stepsArray.map(function (_a, stepIndex) {
    var _b;
    var name = _a.name,
      description = _a.description,
      actions = _a.actions;
    var isStepComplete = currentStepIndex > stepIndex;
    var isStepActive = currentStepIndex === stepIndex;
    var stepClasses = classnames(styles.step, (_b = {}, _b[styles.isActive] = isStepActive, _b[styles.isComplete] = isStepComplete, _b));
    var useLoadingSpinner = hasLoadingSpinner && isStepActive;
    return /*#__PURE__*/React.createElement("div", __assign({
      // eslint-disable-next-line react/no-array-index-key
      key: stepIndex,
      className: stepClasses
    }, parseMetadata({
      testId: (metadata === null || metadata === void 0 ? void 0 : metadata.testId) ? metadata.testId + "-step" : 'progress-tracker-step',
      actionName: (metadata === null || metadata === void 0 ? void 0 : metadata.actionName) ? metadata.actionName + "-step" : 'progress-tracker-step'
    })), /*#__PURE__*/React.createElement(Typography, {
      token: "body-strong-base",
      component: "span",
      className: styles.stepNumber
    }, !isStepComplete && !useLoadingSpinner ? !hideProgressNumbers && stepIndex + 1 : /*#__PURE__*/React.createElement(Icon, {
      name: useLoadingSpinner ? 'sync-alt' : 'check',
      size: 13,
      spin: useLoadingSpinner,
      color: useLoadingSpinner ? 'icon-on-primary' : 'icon-success',
      metadata: {
        testId: "progress-tracker-step-" + (useLoadingSpinner ? 'loading' : 'tick')
      }
    })), /*#__PURE__*/React.createElement(Inline, {
      className: styles.contentContainer
    }, /*#__PURE__*/React.createElement(Stack, null, /*#__PURE__*/React.createElement(Typography, {
      token: "heading-medium",
      component: "div"
    }, name), description && /*#__PURE__*/React.createElement(Typography, {
      token: "body-base",
      component: "div",
      className: styles.description
    }, description)), actions && /*#__PURE__*/React.createElement(React.Fragment, null, actions)));
  }));
};
export { ProgressTracker };
//# sourceMappingURL=index.js.map
