import React from 'react';
import { PropsWithMetadata } from '@highlight-ui/utils-commons';
declare type StepOption = {
    /** Specify the step name to display */
    name: string;
    /** Specify the step description to display */
    description?: string;
    /** Specify the step actions to display */
    actions?: React.ReactNode;
};
export declare type ProgressTrackerPropsWithStepNames = PropsWithMetadata<{
    /** Specify the step names to display */
    stepNames: string[];
    /** Specify the steps to display */
    steps: StepOption[];
    /** Specify the active step index. This updates the style for active and previous step names */
    currentStepIndex: number;
    /** Allows providing a custom classname */
    className?: string;
    /** Use loading spinner for active step */
    hasLoadingSpinner?: boolean;
    hideProgressNumbers?: boolean;
}>;
declare type RequireOnlyOne<T, Keys extends keyof T = keyof T> = Pick<T, Exclude<keyof T, Keys>> & {
    [K in Keys]-?: Required<Pick<T, K>> & Partial<Record<Exclude<Keys, K>, undefined>>;
}[Keys];
export declare type ProgressTrackerProps = RequireOnlyOne<ProgressTrackerPropsWithStepNames, 'steps' | 'stepNames'>;
declare const ProgressTracker: React.FC<ProgressTrackerProps>;
export default ProgressTracker;
